[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.122 and 1.139

version 1.122, 2021/12/24 02:36:13 version 1.139, 2022/01/05 23:34:11
Line 34 
Line 34 
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
 VERBOSE=false  DRYRUN=false
   VERBOSE=0
 DELETE=false  DELETE=false
 DOWNLOAD=true  DOWNLOAD=true
 INSTALL=true  INSTALL=true
 LOCALSRC=  LOCALSRC=
   
   unset FTPPID
   unset FWPKGTMP
   REMOVE_LOCALSRC=false
   cleanup() {
           set +o errexit # ignore errors from killing ftp
           [ "${FTPPID:-}" ] && kill -TERM -"$FTPPID" 2>/dev/null
           [ "${FWPKGTMP:-}" ] && rm -rf "$FWPKGTMP"
           "$REMOVE_LOCALSRC" && rm -rf "$LOCALSRC"
   }
   trap cleanup EXIT
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
Line 57 
Line 69 
 }  }
   
 fetch() {  fetch() {
         local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit _error=''
   
         # If we're not in the installer,          # If we're not in the installer,
         # we have su(1) and doas(1) is unlikely to be configured.          # we have su(1) and doas(1) is unlikely to be configured.
         set -o monitor # make sure ftp gets its own process group          set -o monitor # make sure ftp gets its own process group
         (          (
         flags=-VM          _flags=-vm
         "$VERBOSE" && flags=-vm          case "$VERBOSE" in
                   0|1) _flags=-VM ;;
                     2) _flags=-Vm ;;
           esac
         if [ -x /usr/bin/su ]; then          if [ -x /usr/bin/su ]; then
                 exec /usr/bin/su -s /bin/ksh "$_user" -c \                  exec /usr/bin/su -s /bin/ksh "$_user" -c \
                     "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"                      "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $_flags -o- '$_src'" > "$_dst"
         else          else
                 exec /usr/bin/doas -u "$_user" \                  exec /usr/bin/doas -u "$_user" \
                     /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $flags -o- "$_src" > "$_dst"                      /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $_flags -o- "$_src" > "$_dst"
         fi          fi
         ) & _pid=$!          ) & FTPPID=$!
         set +o monitor          set +o monitor
   
         trap "kill -TERM '-$_pid' 2>/dev/null; exit 1" EXIT INT QUIT ABRT TERM  
   
         SECONDS=0          SECONDS=0
         _last=0          _last=0
         while kill -0 -"$_pid" 2>/dev/null; do          while kill -0 -"$FTPPID" 2>/dev/null; do
                 if [[ $SECONDS -gt 12 ]]; then                  if [[ $SECONDS -gt 12 ]]; then
                         set -- $( ls -ln "$_dst" 2>/dev/null )                          set -- $( ls -ln "$_dst" 2>/dev/null )
                         if [[ $_last -ne $5 ]]; then                          if [[ $_last -ne $5 ]]; then
Line 87 
Line 100 
                                 SECONDS=0                                  SECONDS=0
                                 sleep 1                                  sleep 1
                         else                          else
                                 kill -INT -"$_pid"                                  kill -INT -"$FTPPID" 2>/dev/null
                                 _error=" (timed out)"                                  _error=" (timed out)"
                         fi                          fi
                 else                  else
Line 96 
Line 109 
         done          done
   
         set +o errexit          set +o errexit
         wait "$_pid"          wait "$FTPPID"
         _exit=$?          _exit=$?
         set -o errexit          set -o errexit
   
         trap "" EXIT INT QUIT ABRT TERM          unset FTPPID
   
         if [ "$_exit" -ne 0 ]; then          if [ "$_exit" -ne 0 ]; then
                 rm -f "$_dst"                  rm -f "$_dst"
Line 117 
Line 130 
         fi          fi
 }  }
   
 devices_needing_firmware() {  firmware_in_dmesg() {
         local _d _m _line _dmesgtail _last='' _nl=$( echo )          local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
         # When we're not in the installer, the dmesg.boot can          # When we're not in the installer, the dmesg.boot can
         # contain multiple boots, so only look in the last one          # contain multiple boots, so only look in the last one
         _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |          _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )"
             grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"  
   
         grep -v '^[[:space:]]*#' "$FWPATTERNS" |          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
             while read -r _d _m; do              while read -r _d _m; do
Line 153 
Line 165 
   
 installed_firmware() {  installed_firmware() {
         local _pre="$1" _match="$2" _post="$3" _firmware          local _pre="$1" _match="$2" _post="$3" _firmware
         set -A _firmware -- $(          set -sA _firmware -- $(
             set +o noglob              set +o noglob
             grep -Fxl '@option firmware' \              grep -Fxl '@option firmware' \
                 "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \                  "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
Line 168 
Line 180 
         done          done
 }  }
   
   detect_firmware() {
           local _devices _last='' _d
   
           set -sA _devices -- $(
               firmware_in_dmesg
               for _d in $( installed_firmware '*' '-firmware-' '*' ); do
                   firmware_devicename "$_d"
               done
           )
   
           [ "${_devices[*]:-}" ] || return 0
           for _d in "${_devices[@]}"; do
                   [ "$_last" = "$_d" ] && continue
                   echo "$_d"
                   _last="$_d"
           done
   }
   
 add_firmware () {  add_firmware () {
         local _f="${1##*/}" _pkgname          local _f="${1##*/}" _m="${2:-Install}" _pkgname
         local _tmpdir="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"          FWPKGTMP="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
         local flags=-VM          local _flags=-vm
         "$VERBOSE" && flags=-vm          case "$VERBOSE" in
         ftp -N "${0##/}" -D "Install" "$flags" -o- "file:${1}" |                  0|1) _flags=-VM ;;
                 tar -s ",^\+,${_tmpdir}/+," \                  2|3) _flags=-Vm ;;
           esac
   
           ftp -N "${0##/}" -D "$_m" "$_flags" -o- "file:${1}" |
                   tar -s ",^\+,${FWPKGTMP}/+," \
                     -s ",^firmware,${DESTDIR}/etc/firmware," \                      -s ",^firmware,${DESTDIR}/etc/firmware," \
                     -C / -zxphf - "+*" "firmware/*"                      -C / -zxphf - "+*" "firmware/*"
   
         _pkgname="$( sed -n '/^@name /{s///p;q;}' "${_tmpdir}/+CONTENTS" )"          _pkgname="$( sed -n '/^@name /{s///p;q;}' "${FWPKGTMP}/+CONTENTS" )"
         if [ ! "$_pkgname" ]; then          if [ ! "$_pkgname" ]; then
                 echo "Failed to extract name from $1, partial install" 2>&1                  echo "Failed to extract name from $1, partial install" 2>&1
                 rm -rf "$_tmpdir"                  rm -rf "$FWPKGTMP"
                   unset FWPKGTMP
                 return 1                  return 1
         fi          fi
   
         # TODO: Should we mark these so real fw_update can -Drepair?          # TODO: Should we mark these so real fw_update can -Drepair?
         ed -s "${_tmpdir}/+CONTENTS" <<EOL          ed -s "${FWPKGTMP}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 195 
Line 230 
 w  w
 EOL  EOL
   
         chmod 755 "$_tmpdir"          chmod 755 "$FWPKGTMP"
         mv "$_tmpdir" "${DESTDIR}/var/db/pkg/${_pkgname}"          mv "$FWPKGTMP" "${DESTDIR}/var/db/pkg/${_pkgname}"
           unset FWPKGTMP
 }  }
   
 delete_firmware() {  delete_firmware() {
         local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
   
         # TODO: Check hash for files before deleting          # TODO: Check hash for files before deleting
         "$VERBOSE" && echo "Uninstalling $_pkg"          [ "$VERBOSE" -gt 1 ] && echo -n "Uninstall $_pkg ..."
         _cwd="${_pkgdir}/$_pkg"          _cwd="${_pkgdir}/$_pkg"
   
         if [ ! -e "$_cwd/+CONTENTS" ] ||          if [ ! -e "$_cwd/+CONTENTS" ] ||
Line 238 
Line 274 
                         rm -f "$_r"                          rm -f "$_r"
                 fi                  fi
         done          done
   
           [ "$VERBOSE" -gt 1 ] && echo " done."
   
           return 0
 }  }
   
 usage() {  usage() {
Line 247 
Line 287 
   
 ALL=false  ALL=false
 OPT_D=  OPT_D=
 while getopts :adDp:v name  while getopts :adDnp:v name
 do  do
        case "$name" in         case "$name" in
        a) ALL=true ;;         a) ALL=true ;;
        d) DELETE=true ;;         d) DELETE=true ;;
        D) OPT_D=true ;;         D) OPT_D=true ;;
          n) DRYRUN=true ;;
        p) LOCALSRC="$OPTARG" ;;         p) LOCALSRC="$OPTARG" ;;
        v) VERBOSE=true ;;         v) VERBOSE=$(( VERBOSE + 1 )) ;;
        :)         :)
            echo "${0##*/}: option requires an argument -- -$OPTARG" >&2             echo "${0##*/}: option requires an argument -- -$OPTARG" >&2
            usage 2             usage 2
Line 283 
Line 324 
 if [ "$OPT_D" ]; then  if [ "$OPT_D" ]; then
         INSTALL=false          INSTALL=false
         LOCALSRC="${LOCALSRC:-.}"          LOCALSRC="${LOCALSRC:-.}"
   elif [ "$LOCALSRC" ]; then
           DOWNLOAD=false
 fi  fi
   
 [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"  
   
 CFILE="$LOCALSRC/$CFILE"  
   
 if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then  if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
         echo "need root privileges" >&2          echo "need root privileges" >&2
         exit 1          exit 1
 fi  fi
   
 set -A devices -- "$@"  set -sA devices -- "$@"
   
 if "$DELETE"; then  if "$DELETE"; then
         [ "$OPT_D" ] && usage 22          [ "$OPT_D" ] && usage 22
   
           # Show the "Uninstalling" message when just deleting not upgrading
           [ "$VERBOSE" -eq 1 ] && VEROBOSE=2
   
         set -A installed          set -A installed
         if [ "${devices[*]:-}" ]; then          if [ "${devices[*]:-}" ]; then
                 "$ALL" && usage 22                  "$ALL" && usage 22
Line 325 
Line 367 
         deleted=''          deleted=''
         if [ "${installed:-}" ]; then          if [ "${installed:-}" ]; then
                 for fw in "${installed[@]}"; do                  for fw in "${installed[@]}"; do
                         delete_firmware "$fw" || continue                          if "$DRYRUN"; then
                                   [ "$VERBOSE" -gt 0 ] && echo "Delete $fw"
                           else
                                   delete_firmware "$fw" || continue
                           fi
                         deleted="$deleted,$( firmware_devicename "$fw" )"                          deleted="$deleted,$( firmware_devicename "$fw" )"
                 done                  done
         fi          fi
   
         deleted="${deleted:+${deleted#,}}"          deleted="${deleted#,}"
         echo "${0:##*/}: deleted ${deleted:-none}";          echo "${0:##*/}: deleted ${deleted:-none}";
   
         exit          exit
 fi  fi
   
   if [ ! "$LOCALSRC" ]; then
       LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
       REMOVE_LOCALSRC=true
   fi
   
   CFILE="$LOCALSRC/$CFILE"
   
 if [ "${devices[*]:-}" ]; then  if [ "${devices[*]:-}" ]; then
         "$ALL" && usage 22          "$ALL" && usage 22
 else  else
         "$VERBOSE" && echo -n "Detecting firmware ..."          [ "$VERBOSE" -gt 1 ] && echo -n "Detect firmware ..."
         set -A devices -- $( devices_needing_firmware )          set -sA devices -- $( detect_firmware )
         "$VERBOSE" &&          [ "$VERBOSE" -gt 1 ] &&
             { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }              { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
 fi  fi
   
Line 379 
Line 432 
         if "$INSTALL" && [ "${installed[*]:-}" ]; then          if "$INSTALL" && [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         if [ "${f##*/}" = "$i.tgz" ]; then                          if [ "${f##*/}" = "$i.tgz" ]; then
                                 "$VERBOSE" && echo "$i already installed"                                  [ "$VERBOSE" -gt 2 ] && echo "Keep $i"
                                 kept="$kept,$d"                                  kept="$kept,$d"
                                 continue 2                                  continue 2
                         fi                          fi
Line 388 
Line 441 
   
         if [ -e "$f" ]; then          if [ -e "$f" ]; then
                 if "$DOWNLOAD"; then                  if "$DOWNLOAD"; then
                         "$VERBOSE" && echo "Verify existing ${f##*/}"                          [ "$VERBOSE" -gt 0 ] && ! "$INSTALL" &&
                         verify "$f" || continue                              echo "Keep/Verify ${f##*/}"
                         "$INSTALL"  || kept="$kept,$d"                          "$DRYRUN"  || verify "$f" || continue
                           "$INSTALL" || kept="$kept,$d"
                 # else assume it was verified when downloaded                  # else assume it was verified when downloaded
                 fi                  fi
         elif "$DOWNLOAD"; then          elif "$DOWNLOAD"; then
                 fetch  "$f" || continue                  if "$DRYRUN"; then
                 verify "$f" || continue                          [ "$VERBOSE" -gt 0 ] && echo "Get/Verify ${f##*/}"
                 "$INSTALL"  || added="$added,$d"                  else
                           [ "$VERBOSE" -eq 1 ] && echo -n "Get/Verify ${f##*/} ..."
                           fetch  "$f" &&
                           verify "$f" ||
                               { [ "$VERBOSE" -eq 1 ] && echo " failed."; continue; }
                           [ "$VERBOSE" -eq 1 ] && ! "$INSTALL" && echo " done."
                   fi
                   "$INSTALL" || added="$added,$d"
         elif "$INSTALL"; then          elif "$INSTALL"; then
                 echo "Cannot install ${f##*/}, not found" >&2                  echo "Cannot install ${f##*/}, not found" >&2
                 continue                  continue
Line 404 
Line 465 
   
         "$INSTALL" || continue          "$INSTALL" || continue
   
         removed=false          update=''
         if [ "${installed[*]:-}" ]; then          if [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         delete_firmware "$i"                          "$DRYRUN" || delete_firmware "$i"
                         removed=true                          update="Update"
                 done                  done
         fi          fi
   
         add_firmware "$f"          "$DRYRUN" || add_firmware "$f" "$update"
   
         if "$removed"; then          f="${f##*/}"
           f="${f%.tgz}"
           if [ "$update" ]; then
                   if [ "$VERBOSE" -gt 0 ] && "$DRYRUN"; then
                       echo "Update $f"
                   elif [ "$VERBOSE" -eq 1 ]; then
                       echo " updated."
                   fi
                 updated="$updated,$d"                  updated="$updated,$d"
         else          else
                   if [ "$VERBOSE" -gt 0 ] && "$DRYRUN"; then
                       echo "Install $f"
                   elif [ "$VERBOSE" -eq 1 ]; then
                       echo " installed."
                   fi
                 added="$added,$d"                  added="$added,$d"
         fi          fi
 done  done

Legend:
Removed from v.1.122  
changed lines
  Added in v.1.139

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>